﻿Imports System.Drawing.Imaging
Imports System.Globalization
Imports Wunnell.Extensions

Public Class Form1

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        dateTimeIsWeekDayCheckBox.Checked = dateTimeIsWeekDayDatePicker.Value.IsWeekDay()

        InitEnumerablePage()
        InitRandomPage()
        InitStringPage()
    End Sub

#Region "Data"

#End Region 'Data

#Region "DateTime"

    Private Sub isWeekDayDatePicker_ValueChanged(sender As Object, e As EventArgs) Handles dateTimeIsWeekDayDatePicker.ValueChanged
        dateTimeIsWeekDayCheckBox.Checked = dateTimeIsWeekDayDatePicker.Value.IsWeekDay()
    End Sub

    Private Sub initialDatePicker_ValueChanged(sender As Object, e As EventArgs) Handles dateTimeAddWeekDaysInitialDatePicker.ValueChanged
        UpdateFinalDate()
    End Sub

    Private Sub addWeekDaysSpinners_ValueChanged(sender As Object, e As EventArgs) Handles dateTimeAddWeekDaysDaysSpinner.ValueChanged,
                                                                                           dateTimeAddWeekDaysHoursSpinner.ValueChanged,
                                                                                           dateTimeAddWeekDaysMinutesSpinner.ValueChanged,
                                                                                           dateTimeAddWeekDaysSecondsSpinner.ValueChanged
        UpdateFinalDate()
    End Sub

    Private Sub UpdateFinalDate()
        Dim wholeDays = dateTimeAddWeekDaysDaysSpinner.Value
        Dim partialDays = ((dateTimeAddWeekDaysSecondsSpinner.Value / 60D + dateTimeAddWeekDaysMinutesSpinner.Value) / 60D + dateTimeAddWeekDaysHoursSpinner.Value) / 24D
        Dim totalDays = If(wholeDays < 0D,
                           wholeDays - partialDays,
                           wholeDays + partialDays)

        dateTimeAddWeekDaysTotalDaysValueLabel.Text = totalDays.ToString("n5")
        dateTimeAddWeekDaysFinalDatePicker.Value = dateTimeAddWeekDaysInitialDatePicker.Value.AddWeekDays(Convert.ToDouble(totalDays))
    End Sub

#End Region 'DateTime

#Region "Enumerable"

    Private Sub InitEnumerablePage()
        enumerableRandomizeItemsListBox.Items.AddRange({"One", "Two", "Three", "Four", "Five", "Six", "Seven", "Eight", "Nine", "Ten"})
    End Sub

    Private Sub enumerableRandomizeItemsListBox_SelectedIndexChanged(sender As Object, e As EventArgs) Handles enumerableRandomizeItemsListBox.SelectedIndexChanged
        enumerableRandomizeDeleteButton.Enabled = enumerableRandomizeItemsListBox.SelectedItem IsNot Nothing
        enumerableRandomizeMoveUpButton.Enabled = enumerableRandomizeItemsListBox.SelectedIndex > 0
        enumerableRandomizeMoveDownButton.Enabled = enumerableRandomizeItemsListBox.SelectedItem IsNot Nothing AndAlso
                                                    enumerableRandomizeItemsListBox.SelectedIndex < enumerableRandomizeItemsListBox.Items.Count - 1
    End Sub

    Private Sub enumerableRandomizeItemTextBox_TextChanged(sender As Object, e As EventArgs) Handles enumerableRandomizeItemTextBox.TextChanged
        enumerableRandomizeAddButton.Enabled = enumerableRandomizeItemTextBox.TextLength > 0
    End Sub

    Private Sub enumerableRandomizeAddButton_Click(sender As Object, e As EventArgs) Handles enumerableRandomizeAddButton.Click
        enumerableRandomizeItemsListBox.Items.Add(enumerableRandomizeItemTextBox.Text)
    End Sub

    Private Sub enumerableRandomizeDeleteButton_Click(sender As Object, e As EventArgs) Handles enumerableRandomizeDeleteButton.Click
        enumerableRandomizeItemsListBox.Items.RemoveAt(enumerableRandomizeItemsListBox.SelectedIndex)
    End Sub

    Private Sub enumerableRandomizeMoveUpButton_Click(sender As Object, e As EventArgs) Handles enumerableRandomizeMoveUpButton.Click

    End Sub

    Private Sub enumerableRandomizeMoveDownButton_Click(sender As Object, e As EventArgs) Handles enumerableRandomizeMoveDownButton.Click

    End Sub

    Private Sub enumerableRandmizeRandmizeButton_Click(sender As Object, e As EventArgs) Handles enumerableRandmizeRandmizeButton.Click
        Dim items = enumerableRandomizeItemsListBox.Items.
                                                    Cast(Of String)().
                                                    Randomize().
                                                    ToArray()

        enumerableRandomizeItemsListBox.Items.Clear()
        enumerableRandomizeItemsListBox.Items.AddRange(items)
    End Sub

    Private Sub enumerableRandmizeSortButton_Click(sender As Object, e As EventArgs) Handles enumerableRandmizeSortButton.Click
        Dim items = enumerableRandomizeItemsListBox.Items.
                                                    Cast(Of String)().
                                                    ToArray()

        Array.Sort(items)

        enumerableRandomizeItemsListBox.Items.Clear()
        enumerableRandomizeItemsListBox.Items.AddRange(items)
    End Sub

#End Region 'Enumerable

#Region "Image"

    Private Sub imageLoadButton_Click(sender As Object, e As EventArgs) Handles imageLoadButton.Click
        Using ofd As New OpenFileDialog
            If ofd.ShowDialog() = DialogResult.OK Then
                imageSourcePictureBox.Image?.Dispose()
                imageSourcePictureBox.ImageLocation = ofd.FileName
            End If
        End Using
    End Sub

    Private Sub imageCopyButton_Click(sender As Object, e As EventArgs) Handles imageCopyButton.Click
        imageDestinationPictureBox.Image?.Dispose()
        imageDestinationPictureBox.Image = imageSourcePictureBox.Image.ToBytes().ToImage()
    End Sub

    Private Sub imageCopyBitmapButton_Click(sender As Object, e As EventArgs) Handles imageCopyBitmapButton.Click
        imageDestinationPictureBox.Image?.Dispose()
        imageDestinationPictureBox.Image = imageSourcePictureBox.Image.ToBytes(ImageFormat.Bmp).ToImage()
    End Sub

    Private Sub imageCopyJpegButton_Click(sender As Object, e As EventArgs) Handles imageCopyJpegButton.Click
        imageDestinationPictureBox.Image?.Dispose()
        imageDestinationPictureBox.Image = imageSourcePictureBox.Image.ToBytes(ImageFormat.Jpeg).ToImage()
    End Sub

#End Region 'Image

#Region "Random"

    Private randomIgnoreCellValueChanged As Boolean

    Private Sub InitRandomPage()
        randomIgnoreCellValueChanged = True

        randomMinValueCheckBox.Checked = True
        randomMinValueSpinner.Value = 1D
        randomMaxValueSpinner.Value = 10D

        Dim totalWeighting = 10.Triangular()

        For i = 1 To 10
            randomDataGridView.Rows.Add(i,
                                        i,
                                        i.AsPercentageOf(totalWeighting))
        Next

        randomIgnoreCellValueChanged = False
    End Sub

    Private Sub RefreshRandomWeightings()
        randomIgnoreCellValueChanged = True

        Dim minValue = Convert.ToInt32(randomMinValueSpinner.Value)
        Dim maxValue = Convert.ToInt32(randomMaxValueSpinner.Value)
        Dim weightingsByValue As New Dictionary(Of Integer, Integer?)
        Dim defaultWeighting = Convert.ToInt32(randomDefaultWeightingSpinner.Value)

        For i = minValue To maxValue
            weightingsByValue.Add(i, defaultWeighting)
        Next

        For Each row As DataGridViewRow In randomDataGridView.Rows
            Dim value = CInt(row.Cells(ValueColumn.Index).Value)
            Dim weightingValue = row.Cells(WeightingColumn.Index).Value
            Dim weighting As Integer? = Nothing

            If weightingValue IsNot Nothing Then
                weighting = CInt(weightingValue)
            End If

            If weightingsByValue.ContainsKey(value) Then
                weightingsByValue(value) = weighting
            End If
        Next

        randomDataGridView.Rows.Clear()

        Dim totalWeighting = weightingsByValue.Values.Sum(Function(w) If(w, defaultWeighting))

        For Each value In weightingsByValue.Keys
            Dim weighting = weightingsByValue(value)

            randomDataGridView.Rows.Add(value,
                                        weighting,
                                        If(weighting, defaultWeighting).AsPercentageOf(totalWeighting))
        Next

        randomIgnoreCellValueChanged = False
    End Sub

    Private Function GetWeightingForRow(row As DataGridViewRow) As Integer
        Dim cellWeighting = row.Cells(WeightingColumn.Index).Value

        If cellWeighting Is Nothing OrElse cellWeighting.ToString() = String.Empty Then
            Return Convert.ToInt32(randomDefaultWeightingSpinner.Value)
        End If

        Return Convert.ToInt32(cellWeighting)
    End Function

    Private Function GetRandomNumber(rng As Random,
                                     useMinValue As Boolean,
                                     minValue As Integer,
                                     maxValue As Integer,
                                     allWeightingsProvided As Boolean,
                                     partialWeightings As IDictionary(Of Integer, Integer),
                                     completeWeightings As Integer(),
                                     useDefaultWeighting As Boolean,
                                     defaultWeighting As Integer) As Integer
        Dim randomNumber As Integer

        If allWeightingsProvided Then
            If useMinValue Then
                randomNumber = rng.NextWithWeighting(minValue, maxValue, completeWeightings)
            Else
                randomNumber = rng.NextWithWeighting(maxValue, completeWeightings)
            End If
        ElseIf useDefaultWeighting Then
            If useMinValue Then
                randomNumber = rng.NextWithWeighting(minValue, maxValue, partialWeightings, defaultWeighting)
            Else
                randomNumber = rng.NextWithWeighting(maxValue, partialWeightings, defaultWeighting)
            End If
        Else
            If useMinValue Then
                randomNumber = rng.NextWithWeighting(minValue, maxValue, partialWeightings)
            Else
                randomNumber = rng.NextWithWeighting(maxValue, partialWeightings)
            End If
        End If

        Return randomNumber
    End Function

    Private Sub randomMinValueCheckBox_CheckedChanged(sender As Object, e As EventArgs) Handles randomMinValueCheckBox.CheckedChanged
        If randomMinValueCheckBox.Checked Then
            If randomMinValueSpinner.Value > randomMaxValueSpinner.Value Then
                randomMinValueSpinner.Value = randomMaxValueSpinner.Value
            End If

            randomMaxValueSpinner.Minimum = randomMinValueSpinner.Value
            randomMinValueSpinner.Enabled = True
        Else
            randomMinValueSpinner.Enabled = False
            randomMinValueSpinner.Value = 0D
        End If
    End Sub

    Private Sub randomMinValueSpinner_ValueChanged(sender As Object, e As EventArgs) Handles randomMinValueSpinner.ValueChanged
        randomMaxValueSpinner.Minimum = randomMinValueSpinner.Value
    End Sub

    Private Sub randomDefaultWeightingCheckBox_CheckedChanged(sender As Object, e As EventArgs) Handles randomDefaultWeightingCheckBox.CheckedChanged
        randomDefaultWeightingSpinner.Enabled = randomDefaultWeightingCheckBox.Checked

        If Not randomDefaultWeightingSpinner.Enabled Then
            randomDefaultWeightingSpinner.Value = 1D
        End If
    End Sub

    Private Sub randomRefreshButton_Click(sender As Object, e As EventArgs) Handles randomRefreshButton.Click
        RefreshRandomWeightings()
    End Sub

    Private Sub randomGenerateButton_Click(sender As Object, e As EventArgs) Handles randomGenerateButton.Click
        Dim occurrencesByValue = randomDataGridView.Rows.
                                                    Cast(Of DataGridViewRow)().
                                                    ToDictionary(Function(row) CInt(row.Cells(ValueColumn.Index).Value),
                                                                 Function(row) 0)
        Dim weightings = randomDataGridView.Rows.
                                            Cast(Of DataGridViewRow)().
                                            ToDictionary(Function(row) CInt(row.Cells(ValueColumn.Index).Value),
                                                         Function(row) If(row.Cells(WeightingColumn.Index).Value Is Nothing,
                                                                          DirectCast(Nothing, Integer?),
                                                                          CInt(row.Cells(WeightingColumn.Index).Value)))
        Dim useMinValue = randomMinValueCheckBox.Checked
        Dim minValue = Convert.ToInt32(randomMinValueSpinner.Value)

        'Upper limit is exclusive.
        Dim maxValue = Convert.ToInt32(randomMaxValueSpinner.Value) + 1

        Dim allWeightingsProvided = weightings.All(Function(kvp) kvp.Value.HasValue)
        Dim partialWeightings = weightings.Where(Function(kvp) kvp.Value.HasValue).
                                           ToDictionary(Function(kvp) kvp.Key,
                                                        Function(kvp) kvp.Value.Value)
        Dim completeWeightings = partialWeightings.Values.ToArray()
        Dim useDeafultWeighting = randomDefaultWeightingCheckBox.Checked
        Dim defaultWeighting = Convert.ToInt32(randomDefaultWeightingSpinner.Value)

        Const generationCount As Integer = 1000000
        Dim rng = New Random()

        For i = 1 To generationCount
            Dim value = GetRandomNumber(rng,
                                        useMinValue,
                                        minValue,
                                        maxValue,
                                        allWeightingsProvided,
                                        partialWeightings,
                                        completeWeightings,
                                        useDeafultWeighting,
                                        defaultWeighting)

            occurrencesByValue(value) += 1
        Next

        For Each row As DataGridViewRow In randomDataGridView.Rows
            Dim value = CInt(row.Cells(ValueColumn.Index).Value)
            Dim occurrences = occurrencesByValue(value)

            row.Cells(OccurrencesColumn.Index).Value = occurrences
            row.Cells(OccurrencesPercentColumn.Index).Value = occurrences.AsPercentageOf(generationCount)
        Next
    End Sub

    Private Sub randomDataGridView_CellValidating(sender As Object, e As DataGridViewCellValidatingEventArgs) Handles randomDataGridView.CellValidating
        Dim weighting As Integer

        If (e.ColumnIndex = WeightingColumn.Index AndAlso
            Not String.IsNullOrEmpty(TryCast(e.FormattedValue, String)) AndAlso
            (Not Integer.TryParse(e.FormattedValue.ToString(), weighting) OrElse
             weighting < 0)) Then
            e.Cancel = True
            MessageBox.Show("Please enter a non-negative integer.",
                            "Invalid Weighting",
                            MessageBoxButtons.OK,
                            MessageBoxIcon.Error)
        End If
    End Sub

    Private Sub randomDataGridView_CellValidated(sender As Object, e As DataGridViewCellEventArgs) Handles randomDataGridView.CellValidated
        If e.ColumnIndex = WeightingColumn.Index Then
            Dim cell As DataGridViewCell = randomDataGridView.Item(e.ColumnIndex, e.RowIndex)
            Dim cellValue = cell.Value

            If (Not String.IsNullOrEmpty(TryCast(cellValue, String))) Then
                cell.Value = Convert.ToInt32(cellValue)
            End If
        End If
    End Sub

    Private Sub randomDataGridView_CellValueChanged(sender As Object, e As DataGridViewCellEventArgs) Handles randomDataGridView.CellValueChanged
        If randomIgnoreCellValueChanged Then
            Return
        End If

        If e.ColumnIndex = WeightingColumn.Index Then
            Dim totalWeighting = randomDataGridView.Rows.Cast(Of DataGridViewRow)().Sum(AddressOf GetWeightingForRow)

            For Each row As DataGridViewRow In randomDataGridView.Rows
                Dim weighting = GetWeightingForRow(row)

                row.Cells(WeightingPercentColumn.Index).Value = weighting.AsPercentageOf(totalWeighting)
            Next
        End If
    End Sub

#End Region 'Random

#Region "String"

    Private Sub InitStringPage()
        stringSubstringSourceTextBox.Text = "abcdefghijklmnopqrstuvwxyz"

        stringTitleCaseInputTextBox.Text = "the QUICK brown Fox jUmPeD OvEr the lazy d0g"
        stringTitleCaseCultureComboBox.DisplayMember = NameOf(CultureInfo.DisplayName)
        stringTitleCaseCultureComboBox.DataSource = CultureInfo.GetCultures(CultureTypes.AllCultures)
    End Sub

#Region "Convert to Title Case"

    Private Sub stringTitleCaseCurrentButton_Click(sender As Object, e As EventArgs) Handles stringTitleCaseCurrentButton.Click
        stringTitleCaseOutputTextBox.Text = If(stringTitleCaseAcronymsCheckBox.Checked,
                                               stringTitleCaseInputTextBox.Text.ToTitle(True),
                                               stringTitleCaseInputTextBox.Text.ToTitle())
    End Sub

    Private Sub stringTitleCaseSelectedButton_Click(sender As Object, e As EventArgs) Handles stringTitleCaseSelectedButton.Click
        Dim culture = DirectCast(stringTitleCaseCultureComboBox.SelectedItem, CultureInfo)

        stringTitleCaseOutputTextBox.Text = If(stringTitleCaseAcronymsCheckBox.Checked,
                                               stringTitleCaseInputTextBox.Text.ToTitle(culture, True),
                                               stringTitleCaseInputTextBox.Text.ToTitle(culture))
    End Sub

    Private Sub stringTitleCaseInvariantButton_Click(sender As Object, e As EventArgs) Handles stringTitleCaseInvariantButton.Click
        stringTitleCaseOutputTextBox.Text = If(stringTitleCaseAcronymsCheckBox.Checked,
                                               stringTitleCaseInputTextBox.Text.ToTitle(True),
                                               stringTitleCaseInputTextBox.Text.ToTitle())
    End Sub

#End Region 'Convert to Title Case

#Region "Substring"

    Private Sub stringSubstringByLengthButton_Click(sender As Object, e As EventArgs) Handles stringSubstringByLengthButton.Click
        Try
            stringSubstringOutputListBox.DataSource = stringSubstringSourceTextBox.Text.SubstringsByLength(Convert.ToInt32(stringSubstringLengthSpinner.Value))
        Catch ex As Exception
            MessageBox.Show(ex.Message, NameOf(SubstringsByLength), MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub stringSubstringsByCountButton_Click(sender As Object, e As EventArgs) Handles stringSubstringsByCountButton.Click
        Try
            stringSubstringOutputListBox.DataSource = stringSubstringSourceTextBox.Text.SubstringsByCount(Convert.ToInt32(stringSubstringCountSpinner.Value))
        Catch ex As Exception
            MessageBox.Show(ex.Message, NameOf(SubstringsByCount), MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

#End Region 'Substring

#End Region 'String

End Class
