﻿Imports System.Drawing
Imports System.IO
Imports System.Runtime.CompilerServices

''' <summary>
''' Contains methods that extend the <see cref="IEnumerable(Of T)"/> interface.
''' </summary>
Public Module EnumerableExtensions

    ''' <summary>
    ''' Converts an array of <see cref="Byte"/> containing image data into an <see cref="Image"/> object.
    ''' </summary>
    ''' <param name="source">
    ''' The input byte array.
    ''' </param>
    ''' <returns>
    ''' The image represented by the input data.
    ''' </returns>
    <Extension>
    Public Function ToImage(source As IEnumerable(Of Byte)) As Image
        Using stream As New MemoryStream(source.ToArray())
            Return Image.FromStream(stream)
        End Using
    End Function

End Module
