﻿Imports System.Runtime.CompilerServices

''' <summary>
''' Contains methods that extend the <see cref="Decimal"/> structure.
''' </summary>
Public Module DecimalExtensions

    ''' <summary>
    ''' Calculates what percentage of a specified value the input Is.
    ''' </summary>
    ''' <param name="source">
    ''' The input number.
    ''' </param>
    ''' <param name="value">
    ''' The number to calculate the percentage of.
    ''' </param>
    ''' <returns>
    ''' The percentage of <i>value</i> that the input represents.
    ''' </returns>
    <Extension>
    Public Function AsPercentageOf(source As Decimal, value As Decimal) As Decimal
        Return 100D * source / value
    End Function

    ''' <summary>
    ''' Calculates a proportion of a specified value determined by the input as a percentage.
    ''' </summary>
    ''' <param name="source">
    ''' The input number.
    ''' </param>
    ''' <param name="value">
    ''' The number to calculate the percentage of.
    ''' </param>
    ''' <returns>
    ''' A value that is the percentage of <i>value</i> specified by the input.
    ''' </returns>
    <Extension>
    Public Function PercentOf(source As Decimal, value As Decimal) As Decimal
        Return source * value / 100D
    End Function

End Module
